//Compare antialiasing using point sampling, linear, and mipmap

#include <stdio.h>
#include <GL/glut.h>
#include <stdlib.h>

int antiOption;
float myTrans=0.0;
static GLuint texName;

#define  winWidth 512
#define  winHeight 512
#define  imageWidth 256
#define  imageHeight 256

GLubyte Image[imageWidth][imageHeight][3]; 

void 
myImage()
{
  int i, j, c;

  for(i=0; i<imageWidth; i++)
    {
      for(j=0; j<imageHeight; j++)
	{
	  c=((j&0x4)==0)*255;

	  Image[i][j][0]=(GLubyte)c;
	  Image[i][j][1]=(GLubyte)c;
	  Image[i][j][2]=(GLubyte)c;
	}
    }
}

void 
myInit()
{
  GLfloat magfilter, minfilter;

  glShadeModel(GL_FLAT);
  glEnable(GL_TEXTURE_2D);
  myImage();

  glGenTextures(1, &texName);
  glBindTexture(GL_TEXTURE_2D, texName);
  glClearColor(0.5, 0.5, 0.5, 1.0);

  switch(antiOption)
    {
    case 1:
      magfilter=GL_NEAREST;
      minfilter=GL_NEAREST;      
      break;
    case 2:
      magfilter=GL_LINEAR;
      minfilter=GL_LINEAR;      
      break;
    case 3:
      magfilter=GL_NEAREST;
      minfilter=GL_NEAREST_MIPMAP_NEAREST;  
      break;
    case 4:
      magfilter=GL_LINEAR;
      minfilter=GL_LINEAR_MIPMAP_LINEAR;      
      break;
    }

  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, magfilter);
  glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, minfilter);

  if((antiOption==4) ||(antiOption==3))
    {
      int err= gluBuild2DMipmaps(GL_TEXTURE_2D, GL_RGB, imageWidth, 
				 imageHeight, GL_RGB, GL_UNSIGNED_BYTE, Image);

      if(err)
	printf("creating mipmap failed");
    }
  else
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, imageWidth, imageHeight, 0, GL_RGB, 
		 GL_UNSIGNED_BYTE, Image);

  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}

void
myReshape(int w, int h)
{
  /* Set up projection transform. */
  glViewport(0, 0, (GLsizei)w, (GLsizei)h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90, 1, 1, 200);
}

void
myDisplay()
{
  glClear(GL_COLOR_BUFFER_BIT);

  glBindTexture(GL_TEXTURE_2D, texName);
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glTranslatef(0.0, 0.0, myTrans);

  glBegin(GL_POLYGON);
  glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, -1.0);
  glTexCoord2f(1.0, 0.0); glVertex3f(1.0, -1.0, -1.0);
  glTexCoord2f(1.0, 1.0); glVertex3f(1.0, 60.0, -100.0);
  glTexCoord2f(0.0, 1.0); glVertex3f(-1.0, 60.0, -100.0);
  
  glEnd();

  glFlush();
}

void
mySpecial(int key, int x, int y) 
{
  float near=myTrans+0.1;
  float far=myTrans-0.1;

  if((key==GLUT_KEY_UP)&&(near<0.1))
    {
      myTrans=near;
      myDisplay();
    }

  else if((key==GLUT_KEY_DOWN)&&(far>-9.9))
    {
      myTrans=far;
      myDisplay();
    }

}

int
main(int argc, char** argv)
{

  glutInit(&argc,argv);
  
  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(0,0);
  glutCreateWindow("point sampling");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glutSpecialFunc(mySpecial);
  antiOption=1;
  myInit();

  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(350,0);
  glutCreateWindow("bilinear");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glutSpecialFunc(mySpecial);
  antiOption=2;
  myInit();

  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(0,350);
  glutCreateWindow("mipmap(nearest)");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glutSpecialFunc(mySpecial);
  antiOption=3;
  myInit();

  glutInitWindowSize(winWidth,winHeight);
  glutInitWindowPosition(350,350);
  glutCreateWindow("mipmap(linear)");
  glutDisplayFunc(myDisplay);
  glutReshapeFunc(myReshape);
  glutSpecialFunc(mySpecial);
  antiOption=4;
  myInit();

  glutMainLoop();

  return 0;
}


